; bitmap Font Include
;
; supports variable width fonts and specific spacing (kerning)
; characters of ascii codes 33 to 126 inclusive are used
; centering not supported ...yet..necessary?
; font is stored in a 10 by 10 bmp image 'array' (94 chars)
; mask is assumed to be $FF00FF
; .bmf format in ints - height
;                     - widths * (94 entries)
;					  - x, y coords of top left * (94 entries)
;
;  C Good  2/2002


Type BmpFont

	Field height
	Field widths  ; membank for char widths
	Field topleft ; membank for topleft coords
	Field bitmap  ; image containing the chars
	
End Type

Global setbmpfont.BmpFont = New BmpFont  ; PRIVATE DATA the currently set Bmpfont

;--------------------------------------------------

Dim widths(94), topleft(94, 2); PRIVATE DATA   used during a make. dont like this...change it

Function dvMakeBmpFont (fontname$, imagefile$, quote_space)

	; cut out bmp fonts from an 'image strip'
	; data for the bmpfont stored in fontfile.bmf, image data in fontfile.bmp
	; quote_space specifies if there is a space between the two
	; parts of the " character since it can change
	; for eg with antialiasing they might be touching
	
		
	fontstrip = LoadImage(imagefile$)
	iw = ImageWidth(fontstrip)
	ih = ImageHeight(fontstrip)
	strip_buff = ImageBuffer(fontstrip)
		
	LockBuffer strip_buff
	
	; find overall top and bottom
	For y = 0 To ih - 1
		For x= 0 To iw - 1
		
			If (ReadPixelFast (x, y, strip_buff) And $FFFFFF) Xor $FF00FF
				top = y
				Goto findbottom
			End If
			
		Next
	Next
	
	.findbottom
	For y = ih - 1 To 0 Step - 1
		For x = 0 To iw - 1
		
			If (ReadPixelFast (x, y, strip_buff) And $FFFFFF) Xor $FF00FF
				bottom = y
				Goto finish
			End If
			
		Next
	Next
	.finish
	
	height = bottom - top + 1
		
	; look for 'spaces' and store the letter positions 
	Repeat 
	
		; find leftside of letter
		For x = start_x To iw - 1
			For y = top To bottom
				
				If (ReadPixelFast (x, y, strip_buff) And $FFFFFF) Xor $FF00FF
					topleft(lettercount, 0) = x
					topleft(lettercount, 1) = top
					start_x = x
					Goto findright
				End If
				
			Next
		Next
		
		; find right side of letter
		.findright
		For x = start_x To iw - 1
			clearline = 1
			For y = top To bottom
				
				If (ReadPixelFast (x, y, strip_buff) And $FFFFFF) Xor $FF00FF
					clearline = 0 : Exit
				End If
				
			Next
			
			If clearline ; rightside of letter found
				If quote_space And lettercount = 1 ;skip clear line in " char if it exists
					quote_space = 0
				Else 
					widths(lettercount) = x - topleft(lettercount, 0)
					start_x = x
					lettercount = lettercount + 1
					Goto letterdone
				End If
			End If
			
		Next
		
		.letterdone

	Until lettercount = 94 
		
	UnlockBuffer strip_buff
	
	; find the max row width
	lettercount = 0 : lettersinrow = 10
	For row = 0 To 9 
		
		If row = 9 Then lettersinrow = 4 ;last row is small but test for completeness
		
		For letter = 0 To lettersinrow - 1
			row_width = row_width + widths(lettercount)
			lettercount = lettercount + 1
		Next
		
		If row_width > max_row_width Then max_row_width = row_width
		row_width = 0
			
	Next
		
	; copy the letter to a font 'array' image
	fontarray = CreateImage(max_row_width, height * 10)	
	lettercount = 0
	For i = 0 To 93
	
		CopyRect topleft(i, 0), top, widths(i), height, newtopleft_x, newtopleft_y, strip_buff, ImageBuffer(fontarray)
		topleft(i, 0) = newtopleft_x : topleft(i, 1) = newtopleft_y
		newtopleft_x = newtopleft_x + widths(i)
		lettercount = (lettercount + 1) Mod 10
		
		If lettercount = 0 ; start a new row
			newtopleft_x = 0
			newtopleft_y = newtopleft_y + height
		EndIf
		
	Next
	
	; write the font image 'array' file and free the images
	SaveImage(fontarray, fontname$ + ".bmp")
	FreeImage fontarray
	FreeImage fontstrip
	
	; write the data file for the font
	fontdata = WriteFile (fontname$ + ".bmf")
	WriteInt(fontdata, height)

	For i = 0 To 93  
		WriteInt(fontdata, widths(i))
	Next	

	For i = 0 To 93  
		WriteInt(fontdata, topleft(i, 0)) ; x
		WriteInt(fontdata, topleft(i, 1)) ; y
	Next
	CloseFile(fontdata)
	
End Function


;--------------------------------------------------

Function dvLoadBmpFont.BmpFont (fontfile$)

	; just specify the full path and name of the .bmf file
	; load up a bmpfont and return the BmpFont type
	
	datafile = ReadFile(fontfile$)
	
	;check both data and bmp files exist
	If (datafile > 0) And FileType(Left$(fontfile$, Len(fontfile$) - 4) + ".bmp")  
	
		temp_bmf.BmpFont = New BmpFont
	
		; set the font height
		temp_bmf\height = ReadInt(datafile)
		
		;setup width bank
		temp_bmf\widths = CreateBank(94 Shl 2)	
		For i = 0 To 93  
			PokeInt(temp_bmf\widths, i Shl 2, ReadInt(datafile))
		Next
		
		;setup topleft coords bank
		temp_bmf\topleft = CreateBank(94 Shl 3)	
		For i = 0 To 93  
			PokeInt(temp_bmf\topleft, i Shl 3, ReadInt(datafile))
			PokeInt(temp_bmf\topleft, i Shl 3 + 4, ReadInt(datafile))
		Next
		
		;load up the bitmap and set pink mask
		temp_bmf\bitmap = LoadImage(Left$(fontfile$, Len(fontfile$) - 4) + ".bmp")
		MaskImage temp_bmf\bitmap, $FF, 0 , $FF
		
		CloseFile(datafile)
		Return temp_bmf
	
	Else
	
		RuntimeError "BmpFont not found"
		
	End If
	
End Function


;--------------------------------------------------

Function dvFreeBmpFont (fontname.BmpFont)

	; delete the bmpfont type and all its data

	If setbmpfont = fontname Then setbmpfont = Null
	FreeBank fontname\widths
	FreeBank fontname\topleft
	FreeImage fontname\bitmap
	Delete fontname
	
End Function


;--------------------------------------------------

Function dvBmpText (dest_x, dest_y, kerning, bmptext$)

	; draw a string with a bitmap font
	; kerning is in pixels
	; --NO-- checking here for font not set etc..
		
	For i = 1 To Len(bmptext$)
		
		letter$ = Mid$(bmptext$, i, 1)
		
		If letter$ = " "  ;handle spaces
		
			letter_offset = letter_offset + setbmpfont\height * 0.4 + kerning
			
		Else
		
			char_offset = Asc(letter$) - 33
			topleft_x = PeekInt(setbmpfont\topleft, char_offset Shl 3)
			topleft_y = PeekInt(setbmpfont\topleft, char_offset Shl 3 + 4)
			width = PeekInt(setbmpfont\widths, char_offset Shl 2)
			DrawImageRect setbmpfont\bitmap, dest_x + letter_offset, dest_y, topleft_x, topleft_y, width, setbmpfont\height 
			letter_offset = letter_offset + width + kerning
			
		End If
		
	Next
	
	
End Function


;-------------------------------------------------

Function dvSetBmpFont (fontname.BmpFont)

	; set the bmp font for dvBmpText and
	; width, height funcs
	
	setbmpfont = fontname
	
End Function

;--------------------------------------------------

Function dvBmpFontHeight ()

	; font height of the set bmp font
	; (from top of highest char to bottom of lowest)
	
	Return setbmpfont\height
	
End Function 


;--------------------------------------------------

Function dvBmpStringWidth (bmptext$, kerning)

	; width of the currently set bmp font string in pixels

	For i = 1 To Len(bmptext$)
		
		letter$ = Mid$(bmptext$, i, 1)
		
		If letter$ = " "  ;handle spaces
		
			totalwidth = totalwidth + setbmpfont\height * 0.4 + kerning
			
		Else
		
			char_offset = Asc(letter$) - 33
			width = PeekInt(setbmpfont\widths, char_offset Shl 2)
			totalwidth = totalwidth + width + kerning
			
		End If
		
	Next

	Return totalwidth - kerning

End Function